USE [ukctocs]
GO
ALTER PROCEDURE GetNameFromVolunteerRef 
(
 @VolunteerRef int, @surname varchar(30) out, @firstnames varchar(50) out
)
AS
SELECT @surname = ukctocs.Volunteers.V_Surname
      ,@firstnames = ukctocs.Volunteers.V_FirstNames
  FROM ukctocs.Volunteers
	WHERE ukctocs.Volunteers.V_VolunteerRef = @VolunteerRef;
return;
GO

CREATE PROCEDURE MatchScanDateForVolunteerRef 
(
 @VolunteerRef int, @BeginDate datetime, @EndDate datetime, @result int out
)
AS
SELECT @result = UltrascanResults.US_UltrascanID
  FROM UltrascanResults
	WHERE(UltrascanResults.US_VolunteerRef = @VolunteerRef) AND ((UltrascanResults.US_ScanDate >= @BeginDate) AND (UltrascanResults.US_ScanDate < @EndDate));
return;
GO

CREATE PROCEDURE ListVolunteerRefForNames 
(
    @surname varchar(30), @firstnames varchar(50) 
)
AS
SELECT Volunteers.V_VolunteerRef
      ,Volunteers.V_Surname
      ,Volunteers.V_FirstNames
  FROM Volunteers WHERE ((Volunteers.V_Surname LIKE @surname) AND (Volunteers.V_FirstNames LIKE @firstnames));
return;
GO

CREATE PROCEDURE ListScanDatesForVolunteerRef 
(
     @VolunteerRef int
)
AS
SELECT UltrascanResults.US_VolunteerRef
      ,UltrascanResults.US_ScanDate
  FROM UltrascanResults WHERE UltrascanResults.US_VolunteerRef = @VolunteerRef;
return;
GO

CREATE PROCEDURE ListNameForVolunteerRef 
(
 @VolunteerRef int
)
AS
SELECT Volunteers.V_VolunteerRef
      ,Volunteers.V_Surname
      ,Volunteers.V_FirstNames
  FROM Volunteers WHERE Volunteers.V_VolunteerRef = @VolunteerRef;
return;
GO