using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using WillStott.MxAppToolbox;

namespace osImageManagerApp
{
    public partial class DlgDICOMViewer : Form, IMxDlgForm 
    {
        public DlgDICOMViewer()
        {
            InitializeComponent();
            axezDICOMX.DCMtoolbar = false;
        }

        private void DlgDICOMViewer_Load(object sender, EventArgs e)
        {
            dicomFileComboBox.SelectedIndex = ( dicomFileComboBox.Items.Count == 0 ) ? -1 : 0;
        }

        internal void AddDicomPathFilename(string p)
        {
            dicomFileComboBox.Items.Add(p);
        }

         private void dicomFileComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (dicomFileComboBox.SelectedIndex > -1)
            {
                string filename = dicomFileComboBox.Items[dicomFileComboBox.SelectedIndex] as string;
                if (filename != null )
                    axezDICOMX.DCMfilename = filename;
            }
        }       
        
        private void showHeaderCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            axezDICOMX.DCMshowHeader = showHeaderCheckBox.Checked;
        }

        public void HelpRequest(object sender, HelpEventArgs hlpevent)
        {
            DlgUtils.ShowHelp(this, "User_Manual_-_Dialog_-_DICOM_Viewer.htm", hlpevent);
        }
    }
}