using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using WillStott.MxAppToolbox;
using osImageManagerApp.Properties;

namespace osImageManagerApp
{
    public partial class DlgSelectItemsForImageTree : Form
    {
        private bool _forVolunteers;
        private bool _forDiskRef;

        public DlgSelectItemsForImageTree()
        {
            InitializeComponent();
            _forVolunteers = false;
            _forDiskRef = false;

        }

        private void DlgSelectItemsForImageTree_Load(object sender, EventArgs e)
        {
            if (_forVolunteers)
            {
                this.Text += Resources.StrDlgTitleForVolunteers;
                textBoxLabel.Text = Resources.StrTextBoxForVolunteers;
                refTextBox.MaxLength = 8;
            }
            if (_forDiskRef)
            {
                this.Text += Resources.StrDlgTitleForDiskRef;
                textBoxLabel.Text = Resources.StrTextBoxForDiskRef;
                refTextBox.MaxLength = 50;
            }
        }

        public string DiskRef { get { return refTextBox.Text; } }
        public bool clearImageTree { get { return clearImageTreeCheckBox.Checked; } }
        public bool ForVolunteers 
        { 
            get { return _forVolunteers; } 
            set { _forVolunteers = value; } 
        }
        public bool ForDiskRef 
        { 
            get { return _forDiskRef; } 
            set { _forDiskRef = value; } 
        }

        public int VolunteerRef 
        { 
            get 
            {
                int rc = -1;
                try
                {
                    if (refTextBox.Text.Length != 8)
                        throw new InvalidOperationException("invalid Volunteer Ref");

                    rc = int.Parse(refTextBox.Text);
                }
                catch (Exception)
                {
                }
                return rc; 
            } 
        }

        private void okButton_Click(object sender, EventArgs e)
        {
            if (_forVolunteers && (VolunteerRef == -1))
            {
                MessageBox.Show(Resources.StrMsgBoxInvalidVolunteerRef, Resources.StrMsgBoxWarning, MessageBoxButtons.OK);
                DialogResult = DialogResult.None;
            }
            else
            {
                DialogResult = DialogResult.OK;
                Close();
            }
        }


        private void HelpRequest(object sender, HelpEventArgs hlpevent)
        {
            if (_forVolunteers)
                DlgUtils.ShowHelp(this, "User_Manual_-_Dialog_-_View_Images_For_Volunteer.htm", hlpevent);
            if (_forDiskRef)
                DlgUtils.ShowHelp(this, "User_Manual_-_Dialog_-_View_Images_For_DiskRef.htm", hlpevent);
        }
    }
}