using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using osImageManagerLib;
using WillStott.MxAppToolbox;

namespace osImageManagerApp
{
    public partial class DlgToolsOptions : Form, IMxDlgForm
    {
        public DlgToolsOptions()
        {
            InitializeComponent();
        }

        private void DlgToolsOptions_Load(object sender, EventArgs e)
        {
            importByExamRadioButton_CheckedChanged(null, null);
        }

        private void importByExamRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            examDirNameTextBox.Enabled = importByExamRadioButton.Checked;
        }

        public DlgProcFileImport.ImportMode ImageImportMode
        {
            set
            {
                if (DlgProcFileImport.ImportMode.ExaminationCollections == value)
                    importByExamRadioButton.Checked = true;
                if (DlgProcFileImport.ImportMode.AllFilesInTree == value)
                    importByDirectoryRadioButton.Checked = true;
                if (DlgProcFileImport.ImportMode.IndividualFile == value)
                    importByFileRadioButton.Checked = true;
            }
            get
            {
                if (importByExamRadioButton.Checked == true)
                    return DlgProcFileImport.ImportMode.ExaminationCollections;
                if (importByDirectoryRadioButton.Checked == true)
                    return DlgProcFileImport.ImportMode.AllFilesInTree;
                return DlgProcFileImport.ImportMode.IndividualFile;
            }
        }

        public bool SurnameFirstQueryUKCTOCS 
        { 
            get { return nameOrderQueryUKCTOCSCheckBox.Checked; } 
            set { nameOrderQueryUKCTOCSCheckBox.Checked = value; } 

        }
        public bool AutoReadAfterBrowseFileImport 
        { 
            get { return autoReadAfterBrowseFileImportCheckBox.Checked; } 
            set { autoReadAfterBrowseFileImportCheckBox.Checked = value; } 
        }

        public string ExamDirName
        {
            get { return examDirNameTextBox.Text; }
            set { examDirNameTextBox.Text = value; }
        }

        private void DlgToolsOptions_FormClosing(object sender, FormClosingEventArgs e)
        {
            if ((this.DialogResult == DialogResult.OK) && (importByExamRadioButton.Checked == true))
            {
                if (DlgProcToolsOptions.ValidateRegex(examDirNameTextBox.Text) == false)
                {
                    e.Cancel = true;
                    throw new UniException("OSA-068", UniException.Reset.AbortOp, UniException.Category.User, "Invalid Regular expression: {0}", examDirNameTextBox.Text);
                }
            }
        }

        public void HelpRequest(object sender, HelpEventArgs hlpevent)
        {
            DlgUtils.ShowHelp(this, "User_Manual_-_Dialog_-_Tools_Options.htm", hlpevent);
        }
    }
}