using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

using WillStott.MxAppToolbox;
using osImageManagerLib;

namespace osImageManagerLib
{
    public class DlgBrowser : IDisposable
    {
        private OpenFileDialog dlg;

        public DlgBrowser()
        {
            dlg = new OpenFileDialog();
            dlg.Filter = Resources.StrOpenDICOMFileDlg;
            dlg.CheckFileExists = true;
            dlg.Multiselect = false;
        }


        public virtual String SelectedDir
        {
            set { dlg.InitialDirectory = value; }
            get { return Utils.GetPath(dlg.FileName); }
        }

        public virtual String SelectedPathFilename
        {
            get { return dlg.FileName; }
            set { dlg.FileName = value; }

        }

        public virtual bool ShowNewFolderButton
        {
            get { return false; }
            set { ; }
        }

        public virtual DialogResult ShowDialog()
        {
            return dlg.ShowDialog();
        }

        #region IDisposable Members

        public void Dispose()
        {
            Dispose(true);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (dlg != null)
                {
                    dlg.Dispose();
                    dlg = null;
                }
            }
        }

        #endregion
    }
}
