using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using WillStott.MxAppToolbox;

namespace osImageManagerLib
{
    public class DlgProcFileExport
    {
        private OsDatabases _databases;
        private DicomFile[] _fileList;

        public DlgProcFileExport()
        {
            _fileList = null;
            _databases = null;
        }

        public void Initialize(OsDatabases databases, ImageRecord[] recs)
        {
            _databases = databases;
            _fileList = new DicomFile[recs.Length];
            for (int x = 0; x < recs.Length; x++)
                _fileList[x] = new DicomFile(recs[x]);
        }

        public void LoadFileListbox(ListBox listbox)
        {
            if ((listbox == null) || (_fileList == null))
                return;
            foreach (DicomFile file in _fileList)
                listbox.Items.Add(file);
        }

        public bool Export(DicomFile file, bool restoreMask, string exportDirectory)
        {
            bool rc = false;
            if ((file != null) && (_databases != null))
                rc = file.WriteToDisk(_databases, restoreMask, exportDirectory + file.CreateDicomFilename());
            return rc;
        }

        public int FileListCount()
        {
            return (_fileList != null) ? _fileList.Length : 0;
        }

        public DicomFile GetFile(int index)
        {
            return ((_fileList != null) && (index >= 0) && (index < _fileList.Length)) ? _fileList[index] : null;
        }

        public bool IsURAAdminLoggedOn()
        {
            return (_databases != null ) ? _databases.IsURAAdminLoggedOn() : false;
        }

    }
}
