using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

using WillStott.MxAppToolbox;


namespace osImageManagerLib
{
    public class DlgProcHelpAbout
    {
        private String   copyright;
        private String   version;
        private String   title;
        private String   notices;

        public DlgProcHelpAbout(Assembly asm, String thirdPartyCopyrightNotice)
        {
            copyright = "";
            version = "";
            title = "";
            notices = "";

            if ((asm != null) && (thirdPartyCopyrightNotice != null))
            {
                object[] attributes = asm.GetCustomAttributes(typeof(AssemblyCopyrightAttribute), false);
                if (attributes.Length > 0)
                    copyright = ((AssemblyCopyrightAttribute)attributes[0]).Copyright;

                attributes = asm.GetCustomAttributes(typeof(AssemblyTitleAttribute), false);
                if (attributes.Length > 0)
                    title = ((AssemblyTitleAttribute)attributes[0]).Title;

                version = @"version" + asm.GetName().Version.ToString();
                notices = Utils.StrLFCR + Utils.StrLFCR + thirdPartyCopyrightNotice;
            } 
        }

        public String Version { get { return version; } }
        public String Copyright { get { return copyright; } }
        public String Title { get { return title; } }
        public String CopyrightNotices { get { return notices; } }

    }
}
