using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using WillStott.MxAppToolbox;

namespace osImageManagerLib
{
    public class Examination
    {
        private string _directory;
        private List<DicomFile> _fileList;

        public Examination()
        {
            Init();
        }

        public Examination(string examDirectory)
        {
            Init();
            _directory = examDirectory;
        }

        public void Add(DicomFile file)
        {
            _fileList.Add(file);
        }

        public void Clear()
        {
            _fileList.Clear();
        }

        public int Count
        {
            get { return _fileList.Count; }
        }

        public DicomFile[] GetList()
        {
            DicomFile[] arr = new DicomFile[_fileList.Count];
            _fileList.CopyTo(arr);
            return arr;
        }

        public bool Contains(DicomFile searchFile)
        {
            return _fileList.Contains(searchFile);
        }

        public override string ToString()
        {
            return string.Format("{0} images in examination : {1}", _fileList.Count, _directory);
        }

        private void Init()
        {
            _fileList = new List<DicomFile>();
            _directory = "";
        }
    }
}
