using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using fit;
using osImageManagerLib;
using WillStott.MxAppToolbox;

namespace osImageManagerLibFIT
{
    public class DirectoryAdapter
    {
        public string PathFilename;

        public DirectoryAdapter(string file)
        {
            int index = file.LastIndexOf(osImageManagerLib.ExecutionTime.Instance.ImageDir);
            if (index > -1)
                PathFilename = file.Substring(index + osImageManagerLib.ExecutionTime.Instance.ImageDir.Length);
            else
                PathFilename = file;
        }
    }

    class DatabaseAdminDialogResults : RowFixture
    {
        public override Type getTargetClass() { return typeof(DirectoryAdapter); }

        public override object[] query()
        {
            DirectoryAdapter[] rc = null;

            List<string> fileList = new List<string>();
            RecurseDirectoryTree(fileList, osImageManagerLib.ExecutionTime.Instance.ImageDir);

            rc = new DirectoryAdapter[fileList.Count];
            for (int index = 0; index < fileList.Count; index++)
                rc[index] = new DirectoryAdapter(fileList[index]);

            return rc;
        }

        private void RecurseDirectoryTree(List<string> list, string filePath)
        {
            FileSystemInfo info = null;
            try
            {
                DirectoryInfo dir = new DirectoryInfo(filePath);
                FileSystemInfo[] items = dir.GetFileSystemInfos();
                foreach (FileSystemInfo item in items)
                {
                    info = item;
                    if (info is DirectoryInfo)
                        RecurseDirectoryTree(list, ((DirectoryInfo)info).FullName);

                    if (info is FileInfo)
                    {
                        list.Add(info.FullName);
                    }
                }
            }
            catch (Exception)
            {
                throw;
            }
        }
    }
}
