using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using fit;
using osImageManagerLib;
using WillStott.MxAppToolbox;

namespace osImageManagerLibFIT
{
    public class DicomFileListAdapter
    {
        public string PathFilename;

        public DicomFileListAdapter(DicomFile file)
        {
            int index = file.Record.DicomPathFilename.LastIndexOf(osImageManagerLib.ExecutionTime.Instance.ImageDir);
            if (index == -1)
                PathFilename = "[image dir not found]";
            else
                PathFilename = file.Record.DicomPathFilename.Substring(index + osImageManagerLib.ExecutionTime.Instance.ImageDir.Length);
        }
    }

    class DicomFileList : RowFixture
    {
        public override Type getTargetClass() { return typeof(DicomFileListAdapter); }

        public override object[] query()
        {
            DicomFileListAdapter[] rc = null;

            if (TestSuiteSetup.IsTestImageDirectoryPresent() == false)
                throw new InvalidOperationException("Image directory not found - repeat UAT setup");

            DicomFileSet dir = new DicomFileSet();
            DicomFile[] fileList = dir.MakeRecordsFromDirectory(osImageManagerLib.ExecutionTime.Instance.ImageDir);

            rc = new DicomFileListAdapter[fileList.Length];
            for (int index = 0; index < fileList.Length; index++)
                rc[index] = new DicomFileListAdapter(fileList[index]);

            return rc;
        }
    }
}
