using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using fit;
using osImageManagerLib;
using WillStott.MxAppToolbox;

namespace osImageManagerLibFIT
{
    public class FileAdapter
    {
        public string Filename;
        public long Size;
        public string CRC;

        public FileAdapter(FileInfo file)
        {
            Filename = file.Name;
            Size = file.Length;
            CRC = CheckSum.CRC32(file.FullName).ToString("X8");
        }
    }

    class DirectoryList : RowFixture
    {
        public override Type getTargetClass() { return typeof(FileAdapter); }

        public override object[] query()
        {
            DirectoryInfo dir = new DirectoryInfo(MockProgram.Instance.OutputDirectory);
            FileInfo[] files = dir.GetFiles();

            FileAdapter[] rc = new FileAdapter[files.Length];
            for (int index = 0; index < files.Length; index++ )
            {
                rc[index] = new FileAdapter(files[index]);
            }
            return rc;
        }
    }
}
