using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

using fit;
using osImageManagerLib;
using WillStott.MxAppToolbox;

namespace osImageManagerLibFIT
{
    public class FileExportDialog : ActionFixture
    {
        private bool _restoreMask;
        private string _exportDirectory;
        private string _recordToExport;

        private DlgProcFileExport _dlgproc;

        public FileExportDialog()
        {
            _dlgproc = new DlgProcFileExport();
            _dlgproc.Initialize(MockProgram.Instance.GetDatabases(), MockTreeView.Instance.GetDicomRecords());
        }

        public void ExportDirectory(string directory) { _exportDirectory = directory; }
        public void RecordToExport(string recordID) { _recordToExport = recordID; }
        public void RestoreMask(bool restoreMask) { _restoreMask = restoreMask; }

    
        public void Export()
        {
            string dir = _exportDirectory.Remove(_exportDirectory.Length - 1);
            if (Directory.Exists(dir) == false)
                Directory.CreateDirectory(dir);
            string msg = DirOps.DeleteMatchingFiles(_exportDirectory, "*.dicom");

            for (int index = 0; index < _dlgproc.FileListCount(); index++)
            {
                DicomFile file = _dlgproc.GetFile(index);
                if ( (_recordToExport == "*") || (_recordToExport == file.Record.DicomRef))
                        _dlgproc.Export(file, _restoreMask, _exportDirectory);
            }
        }
    }
}
