using System;
using System.Collections.Generic;
using System.Text;

using fit;
using osImageManagerLib;
using WillStott.MxAppToolbox;

namespace osImageManagerLibFIT
{
    public class ImageExtAdapter
    {
        public string DicomRef;
        public string DicomFileSize;
        public string MaskFile;

        public ImageExtAdapter(ImageRecord rec)
        {
            DicomRef = rec.DicomRef;
            DicomFileSize = rec.DicomFileSize.ToString();
            MaskFile = rec.MaskFileLabel;
        }
    }

    class ImageExtList : RowFixture
    {
        public override Type getTargetClass() { return typeof(ImageExtAdapter); }

        public override object[] query()
        {
            ImageExtAdapter[] rc = null;

            OsDatabases db = new OsDatabases();
            db.Connect(TestSuiteSetup.AdminUser, TestSuiteSetup.AdminUserPassword);

            ImageRecord[] imageList = db.GetAllImageDetailsForDiskRef("UAT");
            rc = new ImageExtAdapter[imageList.Length];
            for (int index = 0; index < imageList.Length; index++)
                rc[index] = new ImageExtAdapter(imageList[index]);

            return rc;
        }
    }
}

