using System;
using System.Collections.Generic;
using System.Text;

using fit;
using osImageManagerLib;
using WillStott.MxAppToolbox;

namespace osImageManagerLibFIT
{
    public class ImageAdapter
    {
        public string CaptureDate;
        public string StoredDate;
        public string StoredBy;
        public string DiskRef;
        public string VolunteerRef;
        public string DicomRef;
        public string Flags;

        public ImageAdapter(ImageRecord rec)
        {
            CaptureDate = rec.AppointmentDate.ToString(ImageRecord.DateFormat);
            StoredDate = rec.ArchiveDate.ToString(ImageRecord.DateFormat);
            StoredBy = rec.ArchiveOperator;
            DiskRef = rec.DiskLabel;
            VolunteerRef = rec.VolunteerRef;
            DicomRef = rec.DicomRef;
            Flags = rec.FlagDetails.Trim();
        }

    }

    class ImageList : RowFixture
    {
        public override Type getTargetClass()  {return typeof(ImageAdapter);  }

        public override object[] query()
        {
            ImageAdapter[] rc = null;

            OsDatabases db = new OsDatabases();
            db.Connect(TestSuiteSetup.AdminUser, TestSuiteSetup.AdminUserPassword);

            ImageRecord[] imageList = db.GetAllImageDetailsForDiskRef("UAT");
            rc = new ImageAdapter[imageList.Length];
            for (int index = 0; index < imageList.Length; index++ )
                rc[index] = new ImageAdapter(imageList[index]);

            return rc;
        }
    }
}
