using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

using fit;
using osImageManagerLib;

namespace osImageManagerLibFIT
{
    public class SelectItemsForImageTreeDialog : ActionFixture
    {
        private string _diskLabel;
        private string _volunteerRef;
        private bool _clearTree;

        public void SetDiskLabel(string label) { _diskLabel = label; }
        public void SetVolunteerRef(string refnum) { _volunteerRef = refnum; }
        public void SetClearTree(bool clear) { _clearTree = clear; }

        public SelectItemsForImageTreeDialog()
        {
            _diskLabel = "UAT";
            _volunteerRef = "99000002";
            _clearTree = true;

        }

        public void DisplayRecordsForDisk()
        {
            MockTreeView.Instance.PopulateTree(-1, _diskLabel, _clearTree);
        }
        public void DisplayRecordsForVolunteer()
        {
            MockTreeView.Instance.PopulateTree(int.Parse(_volunteerRef), null, _clearTree);
        }
    }

    public class ImageTreeAdapter
    {
        public string NodePath;
        public string Text;


        public ImageTreeAdapter(TreeNode node)
        {
            if (node == null)
            {
                NodePath = "(null)";
                Text = "(!!!invalid!!!)";
            }
            else
            {
                NodePath = node.FullPath;
                Text = node.Text;
            }
        }
    }

    class ImageTreeViewList : RowFixture
    {
        public override Type getTargetClass() { return typeof(ImageTreeAdapter); }

        public override object[] query()
        {
            ImageTreeAdapter[] rc = null;
            int nodeCount = MockTreeView.Instance.GetNodeCount();
            rc = new ImageTreeAdapter[nodeCount];
            for (int index = 0; index < nodeCount; index++)
                rc[index] = new ImageTreeAdapter(MockTreeView.Instance.GetNode(index));
            return rc;
        }
    }
}
