using System;
using System.Collections.Generic;
using System.Text;
using WillStott.MxAppToolbox;
using osImageManagerLib;

namespace osImageManagerLibFIT
{
    public class MockProgram : Program
    {
        private bool _mainFormClosing;
        private UniLog _uniEventLog;
        private string _helpFilePathName;
        private bool _verboseLog;
        private string _exportDirectory;
        private string[] _queryRecs;

        private OsDatabases _databases;
        
        private MockProgram() { }
        static MockProgram()
        {
            try
            {
                Program.Instance = new MockProgram();
                MockProgram.Instance._mainFormClosing = true;	
                MockProgram.Instance._uniEventLog = new UniLog();
                MockProgram.Instance._uniEventLog.Name = "osImageManagerApp";
                MockProgram.Instance._verboseLog = true;
                MockProgram.Instance._exportDirectory = "Output";

                MockProgram.Instance._databases = new OsDatabases();
                MockProgram.Instance._databases.Connect(TestSuiteSetup.AdminUser, TestSuiteSetup.AdminUserPassword);
            }
            catch (Exception e)
            {		//unless you end the program here a TypeInitializationException is thrown as the ctor failed
                Program.FatalErrorAbend("MockProgram.MockProgram()", e.Message);
            }
        }
        static public new MockProgram Instance
        {
            get { return Program.Instance as MockProgram; }
        }

        public OsDatabases GetDatabases() { return Instance._databases; }

        public void SetQueryResult(string result)
        {
            Instance._queryRecs = result.Split(new char[1] { ',' });
        }
        public int GetQueryResultCnt() { return Instance._queryRecs.Length; }
        public string GetQueryResultRec(int index) { return Instance._queryRecs[index]; }

        public string OutputDirectory
        {
            set { Instance._exportDirectory = value; }
            get { return Instance._exportDirectory; }
        }
        
        public override void MainArgProc(string[] args)
        {
        }

        public override string HelpFilePathName
        {
            get { return _helpFilePathName; }
            set { _helpFilePathName = value; }
        }

        public override UniLog AppLog
        {
            get { return _uniEventLog; }
        }
        public override bool VerboseLog
        {
            get { return _verboseLog; }
            set { _verboseLog = value; }
        }

        public override bool MainFormClosing
        {
            get { return _mainFormClosing; }
            set { _mainFormClosing = value; }
        }

        public override UniMsgList ErrMsgs
        {
            get { return null; }
        }

        public override bool CloseAllDocuments(bool AllowCancel)
        {
            return true;
        }

    }
}
