using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;

using osImageManagerLib;

namespace osImageManagerLibFIT
{
    public class MockTreeView
    {
        private static MockTreeView _mockTreeView = null;
        private ImageRecordTreeView _tree;
        private bool _initDone;

        private MockTreeView() { }

        static MockTreeView()
        {
            _mockTreeView = new MockTreeView();
            _mockTreeView._tree = new ImageRecordTreeView();
            _mockTreeView._initDone = false;
        }

        static public MockTreeView Instance 
        { 
            get 
            {
                if (_mockTreeView._initDone == false)
                    _mockTreeView.Init();
                return _mockTreeView; 
            } 
        }

        public void Init()
        {
            _mockTreeView._tree.Init(MockProgram.Instance.GetDatabases(), new RegionalCentres(), Path.GetTempFileName(), new ToolStripStatusLabel(), new ToolStripMenuItem(), MockProgram.Instance);
            _mockTreeView._initDone = true;
        }

        public int GetNodeCount() { return MockTreeView.Instance._tree.GetNodeCount(true); }
        public TreeNode GetNode(int index) { return MockTreeView.Instance._tree.GetNode(index); }

        public int PopulateTree(int VolunteerRef, string DiskRef, bool ClearExisting)
        {
            return _mockTreeView._tree.PopulateTree(VolunteerRef, DiskRef, ClearExisting);
        }

        public ImageRecord[] GetDicomRecords()
        {
            return _mockTreeView._tree.GetDicomRecords();
        }

    }
}
