using System;
using System.Collections.Generic;
using System.Text;

using fit;
using osImageManagerLib;

namespace osImageManagerLibFIT
{
    public class QueryVolunteersDialog : ActionFixture
    {
        private string _volunteerRef;
        private string _surName;
        private string _firstNames;
        private string _result;

        public QueryVolunteersDialog()
        {
            _volunteerRef = "";
            _surName = "";
            _firstNames = "";
        }

        public void VolunteerRef(string referenceNo) { _volunteerRef = referenceNo; }
        public void Surname(string name) { _surName = name; }
        public void FirstNames(string names) { _firstNames = names; }
        public string Result() { return _result; }

        public void Query()
        {
            string rc = "";
            if ( _volunteerRef.Length == 0 )
                rc = MockProgram.Instance.GetDatabases().GetUKCTOCSQueryResults(OsDatabases.ListVolunteerRefForNamesSP, _surName, _firstNames);
            else
                rc = MockProgram.Instance.GetDatabases().GetUKCTOCSQueryResults(OsDatabases.ListNameForVolunteerRefSP, _volunteerRef, "");

            _result = PackageResult(rc);
        }

        private string PackageResult(string result)
        {
            string rc = result;
            string newline = "\r\n";
            int start = rc.IndexOf(newline);
            if (start > -1)
                rc = rc.Substring(start + newline.Length);
            rc = rc.Trim();
            rc = rc.Replace("\t", ",");
            start = rc.IndexOf(",");
            if (start > -1)
                result = rc.Substring(0, start);
            int end = rc.IndexOf(",", start + 1);
            if (end > -1)
                result += "," + rc.Substring(start + 1).Trim();
            return rc = result;
        }
    }

    public class QueryScanDatesDialog : ActionFixture
    {
        private string _volunteerRef;
        private string _result;

        public QueryScanDatesDialog()
        {
            _volunteerRef = "";
        }

        public void VolunteerRef(string referenceNo) { _volunteerRef = referenceNo; }
        public string Result() { return _result; }

        public void Query()
        {
            string rc = "";

            rc = MockProgram.Instance.GetDatabases().GetUKCTOCSQueryResults(OsDatabases.ListScanDatesForVolunteerRefSP, _volunteerRef, "");

            _result = PackageResult(rc, _volunteerRef);
        }

        private string PackageResult(string result, string volref)
        {
            string rc = "";
            string tmp = "";
            int count = 0;

            int end = 0;
            result = result.Replace(volref, "");
            string[] lines = result.Split(new char[1] { '\n' });
            foreach (string line in lines)
            {
                tmp = line.Replace("\t", "").Trim();
                tmp = tmp.Replace('/', '-');
                end = tmp.IndexOf(' ');
                if ((count > 0) && (end != -1))
                    rc += tmp.Substring(0, end) + ((count+1 < lines.Length-1 ) ? "," : "");
                count++;
            }
            MockProgram.Instance.SetQueryResult(rc);
            return rc;
        }
    }

    public class QueryRecAdapter
    {
        public string AppointmentDate;

        public QueryRecAdapter(string rec)
        {
            AppointmentDate = rec;
        }
    }

    class QueryRecList : RowFixture
    {
        public override Type getTargetClass() { return typeof(QueryRecAdapter); }

        public override object[] query()
        {
            QueryRecAdapter[] rc = null;

            rc = new QueryRecAdapter[MockProgram.Instance.GetQueryResultCnt()];
            for (int index = 0; index < MockProgram.Instance.GetQueryResultCnt(); index++)
                rc[index] = new QueryRecAdapter(MockProgram.Instance.GetQueryResultRec(index));

            return rc;
        }
    }
}
