using System;
using System.Text;
using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Windows.Forms;

using WillStott.MxAppToolbox;
using osImageManagerLib;

namespace osImageManagerLibUnitTests
{
    /// <summary>
    /// Summary description for DlgBrowser
    /// </summary>
    [TestClass]
    public class DlgBrowserTests
    {
        private DlgBrowser dlg;
        private MockBrowserDlg mockdlg;


        public DlgBrowserTests()
        {
            dlg = new DlgBrowser();
            mockdlg = new MockBrowserDlg();
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void SelectedDir()
        {
            dlg.SelectedDir = "abc";
            Assert.AreEqual("", dlg.SelectedDir);   //only works after showdialog

            Assert.AreEqual("", mockdlg.SelectedDir);
            Assert.AreEqual(DialogResult.OK, mockdlg.ShowDialog());
            Assert.AreEqual("C:\\temp\\", mockdlg.SelectedDir);  
        }

        [TestMethod]
        public void SelectedPathFilename()
        {
            dlg.SelectedPathFilename = "123";
            Assert.AreEqual("123", dlg.SelectedPathFilename);   
        }

        [TestMethod]
        public void ShowNewFolderButton()
        {
            dlg.ShowNewFolderButton = true;
            Assert.IsFalse(dlg.ShowNewFolderButton);
            dlg.ShowNewFolderButton = false;
            Assert.IsFalse(dlg.ShowNewFolderButton);
        }

        [TestMethod]
        public void Dispose()
        {
            dlg.Dispose();
        }
    }
}
