﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using osImageManagerLib;
using System.Windows.Forms;
using System.IO;
using osImageManagerLibFIT;
namespace osImageManagerLibUnitTests
{
    /// <summary>
    ///This is a test class for osImageManagerLib.DlgProcFileExport and is intended
    ///to contain all osImageManagerLib.DlgProcFileExport Unit Tests
    ///</summary>
    [TestClass()]
    public class DlgProcFileExportTest
    {
        private TestContext testContextInstance;
        private OsDatabases db;
        private DlgProcFileExport dlgproc;

        public DlgProcFileExportTest()
        {
            db = new OsDatabases();
            db.Connect(TestSuiteSetup.AdminUser, TestSuiteSetup.AdminUserPassword);

            List<ImageRecord> list = new List<ImageRecord>();
            DicomFileSet disk = new DicomFileSet();
            DicomFile[] files = disk.MakeRecordsFromDirectory(ExecutionTime.Instance.DataDir);
            foreach (DicomFile file in files)
            {
                file.ReadFromDisk(db, MockProgram.Instance);
                list.Add(file.Record);
            }
            dlgproc = new DlgProcFileExport();
            dlgproc.Initialize(db, list.ToArray());
        }

        [ClassInitialize()]
        public static void DicomMaskTestsInitialize(TestContext testContext)
        {
            TestSuiteSetup.CreateStdDirAndSampleFiles(TestSuiteSetup.ProjectRootFromUnitTestRuntime, MockProgram.Instance);
            if (Directory.Exists(ExecutionTime.Instance.OutputDir) == false)
                Directory.CreateDirectory(ExecutionTime.Instance.OutputDir);

        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for DlgProcFileExport ()
        ///</summary>
        [TestMethod()]
        public void CtorOK()
        {
            DlgProcFileExport target = new DlgProcFileExport();

            Assert.IsFalse(target.IsURAAdminLoggedOn());
            Assert.IsNull(target.GetFile(0));
            Assert.AreEqual(0, target.FileListCount());
            Assert.IsFalse(target.Export(null, false, "xxx"));
            Assert.IsFalse(target.Export(new DicomFile(), false, "xxx"));
            target.LoadFileListbox(null);
            target.LoadFileListbox(new ListBox());
        }

        /// <summary>
        ///A test for Initialize (OsDatabases, ImageRecord[])
        ///</summary>
        [TestMethod()]
        public void Initialize()
        {
            Assert.IsNotNull(dlgproc.GetFile(0));
        }


        /// <summary>
        ///A test for IsURAAdminLoggedOn ()
        ///</summary>
        [TestMethod()]
        public void IsURAAdminLoggedOnTest()
        {
            db.Disconnect();
            Assert.IsTrue(db.Connect(TestSuiteSetup.OpUser, TestSuiteSetup.OpUserPassword));
            Assert.IsFalse(dlgproc.IsURAAdminLoggedOn());

            db.Disconnect();
            Assert.IsTrue(db.Connect(TestSuiteSetup.GuestUser, TestSuiteSetup.GuestUserPassword));
            Assert.IsFalse(dlgproc.IsURAAdminLoggedOn());

            db.Disconnect();
            Assert.IsTrue(db.Connect(TestSuiteSetup.AdminUser, TestSuiteSetup.AdminUserPassword));
            Assert.IsTrue(dlgproc.IsURAAdminLoggedOn());
        }

        /// <summary>
        ///A test for LoadFileListbox (ListBox)
        ///</summary>
        [TestMethod()]
        public void LoadFileListboxTest()
        {
            ListBox listbox = new ListBox();
            dlgproc.LoadFileListbox(listbox);
            Assert.AreEqual(7, listbox.Items.Count);
        }

        /// <summary>
        ///A test for FileListCount ()
        ///</summary>
        [TestMethod()]
        public void FileListCountTest()
        {
            Assert.AreEqual(7, dlgproc.FileListCount());
        }

        /// <summary>
        ///A test for GetFile (int)
        ///</summary>
        [TestMethod()]
        public void GetFileTest()
        {
            Assert.AreEqual(7, dlgproc.FileListCount());
            Assert.IsNull(dlgproc.GetFile(-1));

            Assert.IsNotNull(dlgproc.GetFile(0));
            Assert.IsNotNull(dlgproc.GetFile(1));
            Assert.IsNotNull(dlgproc.GetFile(2));
            Assert.IsNotNull(dlgproc.GetFile(3));
            Assert.IsNotNull(dlgproc.GetFile(4));
            Assert.IsNotNull(dlgproc.GetFile(5));
            Assert.IsNotNull(dlgproc.GetFile(6));

            Assert.IsNull(dlgproc.GetFile(7));
        }

        /// <summary>
        ///A test for Export (DicomFile, bool, string)
        ///</summary>
        [TestMethod()]
        public void ExportTest()
        {
            DicomFile file = dlgproc.GetFile(0);

            Assert.IsFalse(File.Exists(ExecutionTime.Instance.OutputDir + file.CreateDicomFilename()));
            Assert.IsTrue(dlgproc.Export(file, false, ExecutionTime.Instance.OutputDir));
            Assert.IsTrue(File.Exists(ExecutionTime.Instance.OutputDir + file.CreateDicomFilename()));
        }
    }
}
