﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using System.Windows.Forms;
using System.IO;

using WillStott.MxAppToolbox;
using osImageManagerLibFIT;
using osImageManagerLib;

namespace osImageManagerLibUnitTests
{
    /// <summary>
    ///This is a test class for osImageManagerLib.DlgProcFileImportExam and is intended
    ///to contain all osImageManagerLib.DlgProcFileImportExam Unit Tests
    ///</summary>
    [TestClass()]
    public class DlgProcFileImportExamTest
    {
        private TestContext testContextInstance;
        DlgProcFileImport _dlgproc;
        OsDatabases _databases;
        ListBox _imageListBox;
        ListBox _correctionsListBox;
        ProgressBar _workProgressBar;
        Label _progressTextLabel;
        Examination _exam1;
        Examination _exam2;
        Examination _exam3;
        Examination _badExam1;
        Examination _badExam2;
        Examination _badExam3;

        public DlgProcFileImportExamTest()
        {
            _imageListBox = new ListBox();
            _correctionsListBox = new ListBox();
            _workProgressBar = new ProgressBar();
            _progressTextLabel = new Label();
            _databases = new OsDatabases();

            _dlgproc = DlgProcFileImport.CreateDlgProc(DlgProcFileImport.ImportMode.ExaminationCollections, _databases, _imageListBox, _correctionsListBox, _workProgressBar, _progressTextLabel, 1, MockProgram.Instance);
            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
            Assert.AreEqual(0, _dlgproc.ImageListCnt);

            DicomFile goodFile = new DicomFile();
            goodFile.Record.NameMismatch = false;
            goodFile.Record.Orphan = false;
            goodFile.Record.Duplicate = false;
            goodFile.Record.ResetUnspecifiedError();
            goodFile.Record.DicomRef = TestSuiteSetup.TestFile000DicomRef;

            DicomFile orphanFile = new DicomFile();
            orphanFile.Record.NameMismatch = false;
            orphanFile.Record.Orphan = true;
            orphanFile.Record.Duplicate = false;
            orphanFile.Record.ResetUnspecifiedError();
            orphanFile.Record.DicomRef = TestSuiteSetup.TestFile000DicomRef;

            DicomFile duplicateFile = new DicomFile();
            duplicateFile.Record.NameMismatch = false;
            duplicateFile.Record.Orphan = false;
            duplicateFile.Record.Duplicate = true;
            duplicateFile.Record.ResetUnspecifiedError();
            duplicateFile.Record.DicomRef = TestSuiteSetup.TestFile000DicomRef;

            DicomFile nameBadFile = new DicomFile();
            nameBadFile.Record.NameMismatch = true;
            nameBadFile.Record.Orphan = false;
            nameBadFile.Record.Duplicate = false;
            nameBadFile.Record.ResetUnspecifiedError();
            nameBadFile.Record.DicomRef = TestSuiteSetup.TestFile000DicomRef;

            DicomFile dicomRefBadFile = new DicomFile();
            dicomRefBadFile.Record.NameMismatch = false;
            dicomRefBadFile.Record.Orphan = false;
            dicomRefBadFile.Record.Duplicate = false;
            dicomRefBadFile.Record.ResetUnspecifiedError();
            dicomRefBadFile.Record.DicomRef = "x";

            DicomFile unspecBadFile = new DicomFile();
            unspecBadFile.Record.NameMismatch = false;
            unspecBadFile.Record.Orphan = false;
            unspecBadFile.Record.Duplicate = false;
            unspecBadFile.Record.UnspecifiedErrorText = "xxx";
            unspecBadFile.Record.DicomRef = TestSuiteSetup.TestFile000DicomRef; 

            _exam1 = new Examination();
            _exam1.Add(goodFile);
            _exam1.Add(goodFile);
            _exam1.Add(goodFile);

            _exam2 = new Examination();
            _exam2.Add(goodFile);
            _exam2.Add(orphanFile);
            _exam2.Add(goodFile);

            _exam3 = new Examination();
            _exam3.Add(duplicateFile);
            _exam3.Add(goodFile);
            _exam3.Add(orphanFile);

            _badExam1 = new Examination();
            _badExam1.Add(duplicateFile);
            _badExam1.Add(nameBadFile);
            _badExam1.Add(orphanFile);

            _badExam2 = new Examination();
            _badExam2.Add(duplicateFile);
            _badExam2.Add(dicomRefBadFile);
            _badExam2.Add(orphanFile);

            _badExam3 = new Examination();
            _badExam3.Add(duplicateFile);
            _badExam3.Add(unspecBadFile);
            _badExam3.Add(orphanFile);

            _databases.Connect(TestSuiteSetup.AdminUser, TestSuiteSetup.AdminUserPassword);
        }

        [ClassInitialize()]
        public static void DlgProcFileImportExamTestInitialize(TestContext testContext)
        {
            Assert.IsTrue(TestSuiteSetup.CreateStdDirAndSampleFiles(TestSuiteSetup.ProjectRootFromUnitTestRuntime, MockProgram.Instance));
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        [TestMethod()]
        public void DialogTitleExam()
        {
            Assert.AreEqual(Resources.StrImportModeExam, _dlgproc.DialogTitle);
        }

        [TestMethod]
        public void ReadFilesExamAllBad()
        {
            _dlgproc.ReadFiles(ExecutionTime.Instance.DataDir, "\\bE\\w*\\b");

            Assert.AreEqual(2, _dlgproc.CorrectionsListCnt);
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
        }

        [TestMethod]
        public void ReadFilesExamOneGood()
        {
            String temp = DicomMask.MaskDir;
            DicomMask.MaskDir = "";
            String targetDir = ExecutionTime.Instance.ImageDir + TestSuiteSetup.Y2004M02Dir + TestSuiteSetup.D04Dir + TestSuiteSetup.E0000001Dir;
            if (Directory.Exists(targetDir) == false)
                Directory.CreateDirectory(targetDir);

            DicomFile file = new DicomFile();
            file.TestReadFromDisk(ExecutionTime.Instance.MonochromeSampleDicomFile);
            file.Record.PatientName = "William^StOTT";
            file.Record.VolunteerRef = "99000002U";
            file.Record.AppointmentDate = new DateTime(2005, 01, 21);
            file.Record.DicomRef = TestSuiteSetup.TestFile001DicomRef;
            file.TestUpdateCacheFromRecord(ExecutionTime.Instance.ImageDir + TestSuiteSetup.TestFile001);
                
            _dlgproc.ReadFiles(ExecutionTime.Instance.DataDir, "\\bE\\w*\\b");

            File.Delete(ExecutionTime.Instance.ImageDir + TestSuiteSetup.TestFile001);
            DicomMask.MaskDir = temp;

            Assert.AreEqual(2, _dlgproc.CorrectionsListCnt);
            Assert.AreEqual(1, _dlgproc.ImageListCnt);
        }

        [TestMethod]
        public void ReadFilesExamRegexNoneFound()
        {
            _dlgproc.ReadFiles(ExecutionTime.Instance.DataDir, "\\bZ\\w*\\b");

            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
        }

        [TestMethod]
        [ExpectedException(typeof(UniException))]
        public void ReadFilesExamRegexNull()
        {
            _dlgproc.ReadFiles(ExecutionTime.Instance.DataDir, null);

            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
        }

        [TestMethod()]
        public void ReadFilesExamDirNoneFound()
        {
            _dlgproc.ReadFiles(ExecutionTime.Instance.ScriptsDir, "\\bE\\w*\\b");
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void ReadFilesExamEmptyLocation()
        {
            _dlgproc.ReadFiles("", "\\bE\\w*\\b");
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void ReadFilesExamNullLocation()
        {
            _dlgproc.ReadFiles(null, "\\bE\\w*\\b");
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
        }

        [TestMethod()]
        public void ImportFilesExam()
        {
            String temp = DicomMask.MaskDir;
            DicomMask.MaskDir = "";
            String targetDir = ExecutionTime.Instance.ImageDir + TestSuiteSetup.Y2004M02Dir + TestSuiteSetup.D04Dir + TestSuiteSetup.E0000001Dir;
            if (Directory.Exists(targetDir) == false)
                Directory.CreateDirectory(targetDir);

            DicomFile file = new DicomFile();
            file.TestReadFromDisk(ExecutionTime.Instance.MonochromeSampleDicomFile);
            file.Record.PatientName = "William^StOTT";
            file.Record.VolunteerRef = "99000002U";
            file.Record.AppointmentDate = new DateTime(2005, 01, 21);
            file.Record.DicomRef = TestSuiteSetup.TestFile001DicomRef;
            file.TestUpdateCacheFromRecord(ExecutionTime.Instance.ImageDir + TestSuiteSetup.TestFile001);

            _dlgproc.ReadFiles(ExecutionTime.Instance.DataDir, "\\bE\\w*\\b");
            Assert.AreEqual(1, _dlgproc.ImageListCnt);

            Assert.AreEqual(1, _dlgproc.ImportFiles("UAT", new DateTime(2006, 8, 21)));

            File.Delete(ExecutionTime.Instance.ImageDir + TestSuiteSetup.TestFile001);
            DicomMask.MaskDir = temp;
            _databases.DeleteDiskLabelImages("UAT");
            ImageRecord rec = new ImageRecord();
            rec.DicomRef = TestSuiteSetup.TestImageDicomRef;
            if (_databases.GetImageIDForDicomRef(rec, MockProgram.Instance).Length == 0)
                TestSuiteSetup.CreateMonochromeImageRecord(MockProgram.Instance);
        }

        [TestMethod()]
        public void ImportFilesExamNone()
        {
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
            Assert.AreEqual(0, _dlgproc.ImportFiles("UAT", new DateTime(2006, 8, 21)));
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void ImportFilesExamBad()
        {
            String targetDir = ExecutionTime.Instance.ImageDir + TestSuiteSetup.Y2004M02Dir + TestSuiteSetup.D04Dir + TestSuiteSetup.E0000001Dir;
            if (Directory.Exists(targetDir) == false)
                Directory.CreateDirectory(targetDir);

            DicomFile file = new DicomFile();
            file.TestReadFromDisk(ExecutionTime.Instance.MonochromeSampleDicomFile);
            file.Record.PatientName = "William^StOTT";
            file.Record.VolunteerRef = "99000002U";
            file.Record.AppointmentDate = new DateTime(2005, 01, 21);
            file.Record.DicomRef = TestSuiteSetup.TestFile001DicomRef;
            file.TestUpdateCacheFromRecord(ExecutionTime.Instance.ImageDir + TestSuiteSetup.TestFile001);

            _dlgproc.ReadFiles(ExecutionTime.Instance.DataDir, "\\bE\\w*\\b");
            File.Delete(ExecutionTime.Instance.ImageDir + TestSuiteSetup.TestFile001);

            Assert.AreEqual(1, _dlgproc.ImageListCnt);
            Examination exam = _imageListBox.Items[0] as Examination;
            DicomFile[] files = exam.GetList();
            files[0].Record.VolunteerRef = "";

            _dlgproc.ImportFiles("UAT", new DateTime(2006, 8, 21));
        }


        [TestMethod]
        public void AcceptClickExamNullParams()
        {
            Assert.IsFalse(_dlgproc.acceptClick(null, _imageListBox));
            Assert.IsFalse(_dlgproc.acceptClick(_correctionsListBox,null));
            Assert.IsFalse(_dlgproc.acceptClick(null, null));
        }

        [TestMethod]
        public void AcceptClickExamEmpty()
        {
            _correctionsListBox.Items.Clear();
            _imageListBox.Items.Clear();
            Assert.IsFalse(_dlgproc.acceptClick(_correctionsListBox, _imageListBox));
            Assert.AreEqual(0, _imageListBox.Items.Count);
            Assert.AreEqual(0, _correctionsListBox.Items.Count);
        }

        [TestMethod]
        public void AcceptClickExamOneCorrectionItem()
        {
            _imageListBox.Items.Clear();
            _correctionsListBox.Items.Clear();
            _correctionsListBox.Items.Add(_exam1);
            _correctionsListBox.SelectedIndex = 0;

            Assert.AreEqual(1, _correctionsListBox.Items.Count);

            Assert.IsTrue(_dlgproc.acceptClick(_correctionsListBox, _imageListBox));

            Assert.AreEqual(1, _imageListBox.Items.Count);
            Assert.AreEqual(0, _correctionsListBox.Items.Count);
        }

        [TestMethod]
        public void AcceptClickExamTwoCorrectionItems()
        {
            _imageListBox.Items.Clear();
            _correctionsListBox.Items.Clear();
            _correctionsListBox.Items.Add(_exam1);
            _correctionsListBox.Items.Add(_exam2);
            _correctionsListBox.SelectedIndex = 1;

            Assert.AreEqual(2, _correctionsListBox.Items.Count);

            Assert.IsTrue(_dlgproc.acceptClick(_correctionsListBox, _imageListBox));

            Assert.AreEqual(1, _imageListBox.Items.Count);
            Assert.AreEqual(1, _correctionsListBox.Items.Count);
        }

        [TestMethod]
        public void AcceptClickExamThreeCorrectionItems()
        {
            _imageListBox.Items.Clear();
            _correctionsListBox.Items.Clear();
            _correctionsListBox.Items.Add(_exam1);
            _correctionsListBox.Items.Add(_exam2);
            _correctionsListBox.Items.Add(_exam3);
            _correctionsListBox.SelectedIndex = 0;

            Assert.AreEqual(3, _correctionsListBox.Items.Count);

            Assert.IsTrue(_dlgproc.acceptClick(_correctionsListBox, _imageListBox));

            Assert.AreEqual(1, _imageListBox.Items.Count);
            Assert.AreEqual(2, _correctionsListBox.Items.Count);
        }

        [TestMethod]
        public void AcceptClickExamBadNameCorrectionItem()
        {
            _imageListBox.Items.Clear();
            _correctionsListBox.Items.Clear();
            _correctionsListBox.Items.Add(_badExam1);
            _correctionsListBox.SelectedIndex = 0;

            Assert.AreEqual(1, _correctionsListBox.Items.Count);

            Assert.IsFalse(_dlgproc.acceptClick(_correctionsListBox, _imageListBox));

            Assert.AreEqual(0, _imageListBox.Items.Count);
            Assert.AreEqual(1, _correctionsListBox.Items.Count);
        }

        [TestMethod]
        public void AcceptClickExamBadDicomRefCorrectionItem()
        {
            _imageListBox.Items.Clear();
            _correctionsListBox.Items.Clear();
            _correctionsListBox.Items.Add(_badExam2);
            _correctionsListBox.SelectedIndex = 0;

            Assert.AreEqual(1, _correctionsListBox.Items.Count);

            Assert.IsFalse(_dlgproc.acceptClick(_correctionsListBox, _imageListBox));

            Assert.AreEqual(0, _imageListBox.Items.Count);
            Assert.AreEqual(1, _correctionsListBox.Items.Count);
        }

        [TestMethod]
        public void AcceptClickExamBadUnspecCorrectionItem()
        {
            _imageListBox.Items.Clear();
            _correctionsListBox.Items.Clear();
            _correctionsListBox.Items.Add(_badExam3);
            _correctionsListBox.SelectedIndex = 0;

            Assert.AreEqual(1, _correctionsListBox.Items.Count);

            Assert.IsFalse(_dlgproc.acceptClick(_correctionsListBox, _imageListBox));

            Assert.AreEqual(0, _imageListBox.Items.Count);
            Assert.AreEqual(1, _correctionsListBox.Items.Count);
        }

        [TestMethod()]
        public void GetFilenamesForSelectedItemExamNull()
        {
            Assert.IsNull(_dlgproc.GetFilenamesForSelectedItem(null));
        }

        [TestMethod()]
        public void GetFilenamesForSelectedItemExam()
        {
            String[] list = _dlgproc.GetFilenamesForSelectedItem(_exam1);
            Assert.AreEqual(3, list.Length);
        }

        [TestMethod()]
        public void GetAcceptButtonStateForSelectionExamNull()
        {
            Assert.IsFalse(_dlgproc.GetAcceptButtonStateForSelection(null));
        }

        [TestMethod()]
        public void GetAcceptButtonStateForSelectionExam()
        {
            DicomFile file = new DicomFile();
             Examination exam = new Examination();
            exam.Add(file);
            Assert.IsTrue(_dlgproc.GetAcceptButtonStateForSelection(exam));
        }

        [TestMethod()]
        public void GetAcceptButtonStateForSelectionExamNameMismatch()
        {
            DicomFile file = new DicomFile();
            file.Record.NameMismatch = true;
            Examination exam = new Examination();
            exam.Add(file);
            Assert.IsFalse(_dlgproc.GetAcceptButtonStateForSelection(exam));
        }

        [TestMethod()]
        public void GetAcceptButtonStateForSelectionExamUnspecError()
        {
            DicomFile file = new DicomFile();
            file.Record.UnspecifiedErrorText = "error";
            Examination exam = new Examination();
            exam.Add(file);
            Assert.IsFalse(_dlgproc.GetAcceptButtonStateForSelection(exam));
        }

        [TestMethod()]
        public void GetAcceptButtonStateForSelectionExamOrphan()
        {
            DicomFile file = new DicomFile();
            file.Record.Orphan = true;
            Examination exam = new Examination();
            exam.Add(file);
            Assert.IsTrue(_dlgproc.GetAcceptButtonStateForSelection(exam));
        }
        [TestMethod()]
        public void OpenBrowserDlgExam()
        {
            Label fileLocation = new Label();
            _dlgproc.BrowserDlg = new MockBrowserDlg();
            Assert.IsNotNull(_dlgproc.BrowserDlg);
            Assert.AreEqual("C:\\temp\\", _dlgproc.OpenBrowseDlg(ExecutionTime.Instance.DataDir, fileLocation));
            Assert.AreEqual("C:\\temp\\", fileLocation.Text);
        }

        [TestMethod()]
        public void OpenBrowserDlgExamNullLabel()
        {
            _dlgproc.BrowserDlg = new MockBrowserDlg();
            Assert.AreEqual("C:\\temp\\", _dlgproc.OpenBrowseDlg(ExecutionTime.Instance.DataDir, null));
        }

        [TestMethod()]
        public void OpenBrowserDlgExamNull()
        {
            _dlgproc.BrowserDlg = null;
            Assert.AreEqual("", _dlgproc.OpenBrowseDlg(ExecutionTime.Instance.DataDir, null));
        }
    }
}
