﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using System.Windows.Forms;
using System.IO;

using WillStott.MxAppToolbox;
using osImageManagerLibFIT;
using osImageManagerLib;

namespace osImageManagerLibUnitTests
{
    /// <summary>
    ///This is a test class for osImageManagerLib.DlgProcFileImportFile and is intended
    ///to contain all osImageManagerLib.DlgProcFileImportFile Unit Tests
    ///</summary>
    [TestClass()]
    public class DlgProcFileImportFileTest
    {
        private TestContext testContextInstance;
        DlgProcFileImport _dlgproc;
        OsDatabases _databases;
        ListBox _imageListBox;
        ListBox _correctionsListBox;
        ProgressBar _workProgressBar;
        Label _progressTextLabel;

        public DlgProcFileImportFileTest()
        {
            _imageListBox = new ListBox();
            _correctionsListBox = new ListBox();
            _workProgressBar = new ProgressBar();
            _progressTextLabel = new Label();
            _databases = new OsDatabases();

            _dlgproc = DlgProcFileImport.CreateDlgProc(DlgProcFileImport.ImportMode.IndividualFile, _databases, _imageListBox, _correctionsListBox, _workProgressBar, _progressTextLabel, 0, MockProgram.Instance);
            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
            Assert.AreEqual(0, _dlgproc.ImageListCnt);

            _databases.Connect(TestSuiteSetup.AdminUser, TestSuiteSetup.AdminUserPassword);
        }

        [ClassInitialize()]
        public static void DlgProcFileImportFileTestInitialize(TestContext testContext)
        {
            Assert.IsTrue(TestSuiteSetup.CreateStdDirAndSampleFiles(TestSuiteSetup.ProjectRootFromUnitTestRuntime, MockProgram.Instance));
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        [TestMethod()]
        public void DialogTitleFile()
        {
            Assert.AreEqual(Resources.StrImportModeFile, _dlgproc.DialogTitle);
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void ReadFilesFileNoneFound()
        {
            _dlgproc.ReadFiles(ExecutionTime.Instance.ScriptsDir + "temp.txt", null);
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void ReadFilesFileEmptyLocation()
        {
            _dlgproc.ReadFiles("", null);
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void ReadFilesFileNullLocation()
        {
            _dlgproc.ReadFiles(null, null);
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
        }

        [TestMethod]
        public void ReadFilesFileBad()
        {
            _dlgproc.ReadFiles(ExecutionTime.Instance.MonochromeSampleDicomFile, null);

            Assert.AreEqual(1, _dlgproc.CorrectionsListCnt);
            Assert.AreEqual(0, _dlgproc.ImageListCnt);
        }

        [TestMethod]
        public void ReadFilesFileGood()
        {
            DicomFile file = new DicomFile();
            file.TestReadFromDisk(ExecutionTime.Instance.MonochromeSampleDicomFile);
            file.Record.PatientName = "William^StOTT";
            file.Record.VolunteerRef = "99000002U";
            file.Record.AppointmentDate = new DateTime(2005, 01, 21);
            file.Record.DicomRef = TestSuiteSetup.TestFile001DicomRef;

            String temp = DicomMask.MaskDir;
            DicomMask.MaskDir = "";
            String targetDir = ExecutionTime.Instance.ImageDir + TestSuiteSetup.Y2004M02Dir + TestSuiteSetup.D04Dir + TestSuiteSetup.E0000001Dir;
            if (Directory.Exists(targetDir) == false)
                Directory.CreateDirectory(targetDir);
            file.TestUpdateCacheFromRecord(ExecutionTime.Instance.ImageDir + TestSuiteSetup.TestFile001);

            _dlgproc.ReadFiles(ExecutionTime.Instance.ImageDir + TestSuiteSetup.TestFile001, null);

            File.Delete(ExecutionTime.Instance.ImageDir + TestSuiteSetup.TestFile001);
            DicomMask.MaskDir = temp;
            Assert.AreEqual(0, _dlgproc.CorrectionsListCnt);
            Assert.AreEqual(1, _dlgproc.ImageListCnt);
        }

        [TestMethod()]
        public void GetAcceptButtonStateForSelectionFileNull()
        {
            Assert.IsFalse(_dlgproc.GetAcceptButtonStateForSelection(null));
        }

        [TestMethod()]
        public void GetAcceptButtonStateForSelectionFileNameMismatch()
        {
            DicomFile file = new DicomFile();
            file.Record.NameMismatch = true;
            Assert.IsFalse(_dlgproc.GetAcceptButtonStateForSelection(file));
        }

        [TestMethod()]
        public void GetAcceptButtonStateForSelectionFileUnspecError()
        {
            DicomFile file = new DicomFile();
            file.Record.UnspecifiedErrorText = "error";
            Assert.IsFalse(_dlgproc.GetAcceptButtonStateForSelection(file));
        }

        [TestMethod()]
        public void GetAcceptButtonStateForSelectionFileOrphan()
        {
            DicomFile file = new DicomFile();
            file.Record.Orphan = true;
            Assert.IsTrue(_dlgproc.GetAcceptButtonStateForSelection(file));
        }

        [TestMethod()]
        public void OpenBrowserDlgFile()
        {
            Label fileLocation = new Label();
            _dlgproc.BrowserDlg = new MockBrowserDlg();
            Assert.IsNotNull(_dlgproc.BrowserDlg);
            Assert.AreEqual("C:\\temp\\", _dlgproc.OpenBrowseDlg(ExecutionTime.Instance.DataDir, fileLocation));
            Assert.AreEqual("C:\\temp\\temp.txt", fileLocation.Text);
        }

        [TestMethod()]
        public void OpenBrowserDlgFileNullLabel()
        {
            _dlgproc.BrowserDlg = new MockBrowserDlg();
            Assert.AreEqual("C:\\temp\\", _dlgproc.OpenBrowseDlg(ExecutionTime.Instance.DataDir, null));
        }

        [TestMethod()]
        public void OpenBrowserDlgFileNull()
        {
            _dlgproc.BrowserDlg = null;
            Assert.AreEqual("", _dlgproc.OpenBrowseDlg(ExecutionTime.Instance.DataDir, null));
        }
    }
}
