﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using osImageManagerLib;
using WillStott.MxAppToolbox;
using osImageManagerLibFIT;

namespace osImageManagerLibUnitTests
{
    /// <summary>
    ///This is a test class for osImageManagerLib.ExaminationCollection and is intended
    ///to contain all osImageManagerLib.ExaminationCollection Unit Tests
    ///</summary>
    [TestClass()]
    public class ExaminationSetTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        [ClassInitialize()]
        public static void DicomFileCollectionTestsInitialize(TestContext testContext)
        {
            TestSuiteSetup.CreateStdDirAndSampleFiles(TestSuiteSetup.ProjectRootFromUnitTestRuntime, MockProgram.Instance);
        }
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for MakeRecordsFromDirectory (string, string)
        ///</summary>
        [TestMethod()]
        public void Ctor()
        {
            string filePath = ExecutionTime.Instance.DataDir; // TODO: Initialize to an appropriate value

            Examination[] expected = new Examination[2];
            expected[0] = new Examination(ExecutionTime.Instance.DataDirExam1);
            expected[0].Add(new DicomFile(ExecutionTime.Instance.ImageDir1DicomFileA));
            expected[1] = new Examination(ExecutionTime.Instance.DataDirExam2);
            expected[1].Add(new DicomFile(ExecutionTime.Instance.ImageDir2DicomFileB));
            expected[1].Add(new DicomFile(ExecutionTime.Instance.ImageDir2DicomFileA));

            ExaminationSet target = new ExaminationSet(filePath, ExaminationSet.DirRegexPattern);
            Assert.AreEqual(3, target.FileCount);
            
            Examination[] actualExams = target.GetExamList();
            DicomFile[] actualFiles = target.GetFileList();
            Assert.AreEqual(3, actualFiles.Length);

            Assert.AreEqual(2, actualExams.Length);          //DataDirExam0 is not included as it is empty
            Assert.AreEqual(1, actualExams[0].Count);
            Assert.AreEqual(2, actualExams[1].Count);

            DicomFile[] expectedFiles1 = new DicomFile[expected[0].Count];
            expectedFiles1 = expected[0].GetList();
            DicomFile[] actualFiles1 = new DicomFile[actualExams[0].Count];
            actualFiles1 = actualExams[0].GetList();

            Assert.AreEqual(expectedFiles1[0].Record.ImageID, actualFiles1[0].Record.ImageID);

            DicomFile[] expectedFiles2 = new DicomFile[expected[1].Count];
            expectedFiles2 = expected[1].GetList();
            DicomFile[] actualFiles2 = new DicomFile[actualExams[1].Count];
            actualFiles2 = actualExams[1].GetList();

            Assert.AreEqual(expectedFiles2[0].Record.ImageID, actualFiles2[0].Record.ImageID);
            Assert.AreEqual(expectedFiles2[1].Record.ImageID, actualFiles2[1].Record.ImageID);

            Assert.AreEqual(actualExams[0], target.GetExaminationForFile(actualFiles1[0]));
            Assert.AreEqual(actualExams[1], target.GetExaminationForFile(actualFiles2[0]));
            Assert.AreEqual(actualExams[1], target.GetExaminationForFile(actualFiles2[1]));
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void CtorBadPath()
        {
            ExaminationSet target = new ExaminationSet("", "@");
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void CtorBadRegex()
        {
            ExaminationSet target = new ExaminationSet(ExecutionTime.Instance.DataDir, "?");
        }

        /// <summary>
        ///A test for RecurseExamDirectoryTree (List&lt;string&gt;, string, string)
        ///</summary>
        [DeploymentItem("osImageManagerLib.dll")]
        [TestMethod()]
        public void RecurseExamDirectoryTreeTest()
        {
            ExaminationSet target = new ExaminationSet();

            osImageManagerLibUnitTests.osImageManagerLib_ExaminationCollectionAccessor accessor = new osImageManagerLibUnitTests.osImageManagerLib_ExaminationCollectionAccessor(target);

            System.Collections.Generic.List<string> examDirectories = new List<string>();

            string filePath = ExecutionTime.Instance.DataDir;

            accessor.RecurseExamDirectoryTree(examDirectories, filePath, ExaminationSet.DirRegexPattern);

            if ( examDirectories.Count == 9 )
                Assert.AreEqual(ExecutionTime.Instance.DataDirExam1, examDirectories[6]); 
            else
                Assert.AreEqual(ExecutionTime.Instance.DataDirExam1, examDirectories[0]); 

        }
    }
}
