﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using osImageManagerLib;
namespace osImageManagerLibUnitTests
{
    /// <summary>
    ///This is a test class for osImageManagerLib.Examination and is intended
    ///to contain all osImageManagerLib.Examination Unit Tests
    ///</summary>
    [TestClass()]
    public class ExaminationTest
    {
        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for Add (DicomFile)
        ///</summary>
        [TestMethod()]
        public void AddTest()
        {
            Examination target = new Examination();

            Assert.AreEqual(0, target.Count);

            DicomFile file1 = new DicomFile();
            target.Add(file1);
            Assert.AreEqual(1, target.Count);

            DicomFile file2 = new DicomFile();
            target.Add(file2);
            Assert.AreEqual(2, target.Count);

            DicomFile file3 = new DicomFile();
            target.Add(file3);
            Assert.AreEqual(3, target.Count);

        }

        /// <summary>
        ///A test for Clear ()
        ///</summary>
        [TestMethod()]
        public void ClearTest()
        {
            Examination target = new Examination();

            Assert.AreEqual(0, target.Count);

            DicomFile file1 = new DicomFile();
            target.Add(file1);
            DicomFile file2 = new DicomFile();
            target.Add(file2);

            Assert.AreEqual(2, target.Count);

            target.Clear();

            Assert.AreEqual(0, target.Count);

        }

        /// <summary>
        ///A test for Examination ()
        ///</summary>
        [TestMethod()]
        public void CtorNoParam()
        {
            Examination target = new Examination();
            Assert.AreEqual("0 images in examination : ", target.ToString());

        }

        /// <summary>
        ///A test for Examination (string)
        ///</summary>
        [TestMethod()]
        public void CtorParam()
        {
            Examination target = new Examination("c:\\Bills");

            Assert.AreEqual("0 images in examination : c:\\Bills", target.ToString());
        }

        /// <summary>
        ///A test for GetList ()
        ///</summary>
        [TestMethod()]
        public void GetListTest()
        {
            Examination target = new Examination();

            DicomFile file1 = new DicomFile();
            target.Add(file1);
            DicomFile file2 = new DicomFile();
            target.Add(file2);
            DicomFile file3 = new DicomFile();
            target.Add(file3);

            DicomFile[] expected = new DicomFile[3];
            expected[0] = file1;
            expected[1] = file2;
            expected[2] = file3;

            DicomFile[] actual = target.GetList();

            CollectionAssert.AreEqual(expected, actual, "osImageManagerLib.Examination.GetList did not return the expected value.");
        }

        /// <summary>
        ///A test for GetList ()
        ///</summary>
        [TestMethod()]
        public void ContainsTest()
        {
            Examination target = new Examination();

            DicomFile fileMissing = new DicomFile();

            DicomFile file1 = new DicomFile();
            target.Add(file1);
            DicomFile file2 = new DicomFile();
            target.Add(file2);
            DicomFile file3 = new DicomFile();
            target.Add(file3);

            Assert.IsTrue(target.Contains(file1));
            Assert.IsTrue(target.Contains(file2));
            Assert.IsTrue(target.Contains(file3));
            Assert.IsFalse(target.Contains(fileMissing));
        }


        /// <summary>
        ///A test for Init ()
        ///</summary>
        [DeploymentItem("osImageManagerLib.dll")]
        [TestMethod()]
        public void InitTest()
        {
            Examination target = new Examination();

            osImageManagerLibUnitTests.osImageManagerLib_ExaminationAccessor accessor = new osImageManagerLibUnitTests.osImageManagerLib_ExaminationAccessor(target);

            accessor.Init();

            Assert.AreEqual("0 images in examination : ", target.ToString());
        }

        /// <summary>
        ///A test for ToString ()
        ///</summary>
        [TestMethod()]
        public void ToStringTest()
        {
            Examination target = new Examination("c:\\Bills");

            DicomFile file1 = new DicomFile();
            target.Add(file1);
            DicomFile file2 = new DicomFile();
            target.Add(file2);

            Assert.AreEqual("2 images in examination : c:\\Bills", target.ToString());
        }
    }
}
