﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using System.Windows.Forms;
using System.IO;

using osImageManagerLib;
using WillStott.MxAppToolbox;
using osImageManagerLibFIT;


namespace osImageManagerLibUnitTests
{
    /// <summary>
    ///This is a test class for osImageManagerLib.ImageRecordTreeView and is intended
    ///to contain all osImageManagerLib.ImageRecordTreeView Unit Tests
    ///</summary>
    [TestClass()]
    public class ImageRecordTreeViewTest
    {
        private TestContext testContextInstance;
        private ImageRecordTreeView target;
        private OsDatabases db = new OsDatabases();

        public ImageRecordTreeViewTest()
        {
            target = new ImageRecordTreeView();
            db = new OsDatabases();
            db.Connect(TestSuiteSetup.AdminUser, TestSuiteSetup.AdminUserPassword);

            target.Init(null, db, new RegionalCentres(), Path.GetTempFileName(), new ToolStripStatusLabel(), new ToolStripMenuItem(), MockProgram.Instance);
        }

        [TestInitialize()]
        public void TestInitialize()
        {
            target.PopulateTree(-1, "UAT", true);
        }

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        [ClassInitialize()]
        public static void ImageRecordTreeTestsInitialize(TestContext testContext)
        {
            TestSuiteSetup.CreateStdDirAndSampleFiles(TestSuiteSetup.ProjectRootFromUnitTestRuntime, MockProgram.Instance);
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion

        [TestMethod]
        [ExpectedException(typeof(UniException))]
        public void InitNullParam2()
        {
            target.Init(null, null, new RegionalCentres(), Path.GetTempFileName(), new ToolStripStatusLabel(), new ToolStripMenuItem(), MockProgram.Instance);
        }

        [TestMethod]
        [ExpectedException(typeof(UniException))]
        public void InitNullParam3()
        {
            target.Init(null, db, null, Path.GetTempFileName(), new ToolStripStatusLabel(), new ToolStripMenuItem(), MockProgram.Instance);
        }

        [TestMethod]
        [ExpectedException(typeof(UniException))]
        public void InitBadParam4()
        {
            target.Init(null, db, new RegionalCentres(), "", new ToolStripStatusLabel(), new ToolStripMenuItem(), MockProgram.Instance);
        }

        [TestMethod]
        [ExpectedException(typeof(UniException))]
        public void InitNullParam4()
        {
            target.Init(null, db, new RegionalCentres(), null, new ToolStripStatusLabel(), new ToolStripMenuItem(), MockProgram.Instance);
        }
        
        [TestMethod]
        [ExpectedException(typeof(UniException))]
        public void InitNullParam5()
        {
            target.Init(null, db, new RegionalCentres(), Path.GetTempFileName(), null, new ToolStripMenuItem(), MockProgram.Instance);
        }

        [TestMethod]
        [ExpectedException(typeof(UniException))]
        public void InitNullParam6()
        {
            target.Init(null, db, new RegionalCentres(), Path.GetTempFileName(), new ToolStripStatusLabel(), null, MockProgram.Instance);
        }

        [TestMethod]
        [ExpectedException(typeof(UniException))]
        public void InitNullParam7()
        {
            target.Init(null, db, new RegionalCentres(), Path.GetTempFileName(), new ToolStripStatusLabel(), new ToolStripMenuItem(), null);
        }

        /// <summary>
        ///A test for BreakOnIndexMatch (int, int, TreeNode, TreeNode)
        ///</summary>
        [DeploymentItem("osImageManagerLib.dll")]
        [TestMethod()]
        public void BreakOnIndexMatchTestNullNode()
        {
            Assert.IsNull(osImageManagerLibUnitTests.osImageManagerLib_ImageRecordTreeViewAccessor.BreakOnIndexMatch(0, 0, null, null));
        }

        [TestMethod()]
        public void BreakOnIndexMatchTestCountNotEqualIndex()
        {
            TreeNode node1 = new TreeNode();
            TreeNode node2 = new TreeNode();

            Assert.AreSame(node1, osImageManagerLibUnitTests.osImageManagerLib_ImageRecordTreeViewAccessor.BreakOnIndexMatch(1, 2, node1, node2));
        }

        [TestMethod()]
        public void BreakOnIndexMatchTestCountEqualIndex()
        {
            TreeNode node1 = new TreeNode("testA");
            TreeNode node2 = new TreeNode("testB");

            Assert.AreSame(node2, osImageManagerLibUnitTests.osImageManagerLib_ImageRecordTreeViewAccessor.BreakOnIndexMatch(1, 1, null, node2));
        }

        /// <summary>
        ///A test for ClearAllNodes ()
        ///</summary>
        [TestMethod()]
        public void ClearAllNodesTest()
        {
            target.ClearAllNodes();

            Assert.AreEqual(1, target.Nodes.Count);
        }

        [TestMethod()]
        public void TotalImagesInTree()
        {
            Assert.AreEqual(1, target.TotalImagesInTree);
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void SelectedImageItemRoot()
        {
            target.SelectTreeItem(null, null, null, null);
            Assert.IsNotNull(target.SelectedImageItem as ImageRecord);
        }

        [TestMethod()]
        public void SelectedImageItem()
        {
            ImageRecord[] recs = db.GetAllImageDetailsForDiskRef("UAT");
            Assert.IsTrue(recs.Length > 0);
            target.SelectTreeItem(recs[0], null, null, null);
            Assert.IsNotNull(target.SelectedImageItem as ImageRecord);
        }

        [TestMethod()]
        public void RemoveSelectedImageItem()
        {
            Assert.AreEqual(1, target.TotalImagesInTree);

            ImageRecord[] recs = db.GetAllImageDetailsForDiskRef("UAT");
            Assert.IsTrue(recs.Length > 0);
            target.SelectTreeItem(recs[0], null, null, null);
            target.RemoveSelectedItem();

            Assert.AreEqual(0, target.TotalImagesInTree);
        }

        [TestMethod()]
        [ExpectedException(typeof(UniException))]
        public void RemoveSelectedRoot()
        {
            Assert.AreEqual(1, target.TotalImagesInTree);

            target.SelectTreeItem(null, null, null, null);
            target.RemoveSelectedItem();
        }

        /// <summary>
        ///A test for GetDicomRecords ()
        ///</summary>
        [TestMethod()]
        public void GetDicomRecordsTest()
        {
            Assert.AreEqual(1, target.GetDicomRecords().Length);
        }

        ///A test for GetNode (int)
        ///</summary>
        [TestMethod()]
        public void GetNodeRoot()
        {
            Assert.AreSame(target.RootNode, target.GetNode(0));
            Assert.IsNotNull(target.GetNode(1) as TreeNode);
            Assert.IsNotNull(target.GetNode(2) as TreeNode);
            Assert.IsNotNull(target.GetNode(3) as TreeNode);
            Assert.IsNotNull(target.GetNode(4) as TreeNode);
        }

        [TestMethod()]
        public void PopulateTreeVolunteer()
        {
            target.PopulateTree(99000002, null, true);
            Assert.AreEqual(1, target.TotalImagesInTree);

        }

        /// <summary>
        ///A test for OnAfterSelect (TreeViewEventArgs)
        ///</summary>
        [DeploymentItem("osImageManagerLib.dll")]
        [TestMethod()]
        public void OnAfterSelectTest()
        {
            Assert.AreEqual(1, target.TotalImagesInTree);

            ImageRecord[] recs = db.GetAllImageDetailsForDiskRef("UAT");
            Assert.IsTrue(recs.Length > 0);
            target.SelectTreeItem(recs[0], null, null, null);

            osImageManagerLibUnitTests.osImageManagerLib_ImageRecordTreeViewAccessor accessor = new osImageManagerLibUnitTests.osImageManagerLib_ImageRecordTreeViewAccessor(target);
            accessor.OnAfterSelect(null);
        }

        /// <summary>
        ///A test for GetRegionCentre (string)
        ///</summary>
        [DeploymentItem("osImageManagerLib.dll")]
        [TestMethod()]
        public void GetRegionCentreTest()
        {
            osImageManagerLibUnitTests.osImageManagerLib_ImageRecordTreeViewAccessor accessor = new osImageManagerLibUnitTests.osImageManagerLib_ImageRecordTreeViewAccessor(target);

            RegionalCentreElement elem = accessor.GetRegionCentre("1111111");
            Assert.IsTrue(elem.Number == "99");
        }

        [TestMethod()]
        public void RefreshAllNodes()
        {
            ImageRecord[] recs = db.GetAllImageDetailsForDiskRef("UAT");
            Assert.IsTrue(recs.Length > 0);
            target.SelectTreeItem(recs[0], null, null, null);

            target.RefreshAllNodes();
            Assert.AreEqual(1, target.TotalImagesInTree);
        }
    }
}
